\section{Methods}
\label{sec:methods-section}

\subsection{Model}
\label{sec:methods-model}
In order to simulate the evolution of COVID-19 epidemic in a given population we defined:
\begin{itemize}
\item $\mathbb{P}$ being the population taken into account (\ie{} set of individuals in a country, city \ldots)
\item $t$ is a \textit{discrete} time step (\ie{} hour, day \ldots)
\item a set $\mathbb{S}$ of \textit{states}: the level of each state $s$ is a real positive number. Let us denote with $m$ the length of this set ($|\mathbb{S}| = m$). $\phi(p, t)$ is the state of indiviual $p$ at time $t$: the function $\phi : \mathbb{P} \rightarrow \mathbb{S}$ is surjective.
\item a subset $\mathbb{F}$ of $\mathbb{S}$ called \textit{final states}: $\forall p \in \mathbb{P}, \phi(p, t) = f \in \mathbb{F} \Rightarrow \phi(p, t + 1) = f$
\item $N = |\mathbb{P}|$ is constant over time: we did not take into account births. Deaths were modeled in one of the states
\item $\frac{\mathrm{d} s}{\mathrm{d} t} = s(t + 1) - s(t) = f_s(\mathbb{S}), f_s : \mathbb{R}^n \rightarrow \mathbb{R}$ \ie{} the net change of state $s$ at time $t$ 
\end{itemize}
The time-evolution of the states was given as a PDE system. In particular, given the following definitions:
\begin{itemize}
\item $S$ is the model state consisting of people \ldots \todo{}
\item \ldots \todo{}
\item $a$ is the parameter from \ldots
\end{itemize}
we built the following PDE system:
\begin{align}
  \frac{\mathrm{d} S(t)}{\mathrm{d} t} &= - \it{b} S(t) \cdot \frac{I_{u}(t)}{N - \left(D(t) + H_m(t) + H_s(t) + I_{cu}(t) \right)} - \it{a} S(t)\\
  \frac{\mathrm{d} E(t)}{\mathrm{d} t} &= \it{b} S(t) \cdot \frac{I_{u}(t)}{N - \left(D(t) + H_m(t) + H_s(t) + I_{cu}(t) \right)} - \it{c} E(t)\\
  \frac{\mathrm{d} I_{u}(t)}{\mathrm{d} t} &= \it{c} E(t) - (\it{d} + \it{e} + \it{f} + \it{g}) \cdot I_{u}(t)\\
  \frac{\mathrm{d} H_{m}(t)}{\mathrm{d} t} &= \it{e} I_{u}(t) - (\it{h} + \it{i}) \cdot H_{m}(t)\\
  \frac{\mathrm{d} H_{s}(t)}{\mathrm{d} t} &= \it{f} I_{u}(t) - (\it{l} + \it{m} + \it{n}) \cdot H_{s}(t)\\
  \frac{\mathrm{d} I_{cu}(t)}{\mathrm{d} t} &= \it{m} H_{s}(t) - (\it{o} + \it{p}) \cdot I_{cu}(t)\\
  \frac{\mathrm{d} R(t)}{\mathrm{d} t} &= \it{d} I_{u}(t) + \it{i} H_{m}(t) + \it{l} H_{s}(t) + \it{o} I_{cu}(t)\\
  \frac{\mathrm{d} D(t)}{\mathrm{d} t} &= \it{g} I_{u}(t) + \it{n} H_{s}(t) + \it{p} I_{cu}(t)\\
  \frac{\mathrm{d} P(t)}{\mathrm{d} t} &= \it{a} S(t)
\end{align}
See \fg[FN-hosp]{} and \ref{sec:2020-05-29-FN-model-hospitalization}

\subsection{Age-stratified model}
\label{sec:methods-model}
See @Jessica figure.

\subsection{Data}
\label{sec:methods-data}
Since data retrieval methods differed greatly from country to country, data format and attributes were qualitatively different in each country examined.
This meant we needed a common abstract representation of each country data. We thus parsed the raw data coming from each country and prettified the format and the attributes.
The inconsistencies were worsened by the fact that the data was highly imprecise and inconsistent even within the same country.
To deal with difficulties we developed pre-processing tecniques for all countries that were applied to each country.

\subsubsection{Sensitivity analysis}
\label{subsec:methods-sensitivity}
In order to reduce bias we performed noise-addition to the entire dataset of each country. In particular we added Gaussian noise (AWGN) to each timeline.
This was necessary since for some timeline data was missing at random (MAR).

\subsubsection{Robustness check}
\label{subsec:methods-robustness}
In order to check the model robustness we performed a number of simulations under a different assumptions set: the output timeline varied linearly on the input data. \newline{}
We considered the following countries data:

\subsubsection{Italy}
\label{subsec:methods-italy}
Data was retrieved from \cite{italyOfficial}. Data had to be pre-processed in a number of ways before actually being fed in into the fitting algorithm:
\begin{itemize}
\item summation across all regions to get italian totals
\item inferring age-stratified quantities based on other countries (e.g Spain) quantities
\end{itemize}

\subsubsection{Spain}
\label{subsec:methods-spain}
Data was retrieved from \cite{spainOfficial}. Pre-processing involved:
\begin{itemize}
\item inferring \no{} recovered
\item interpolating days were data was either missing or explicitly wrong. We used cubic spline interpolation (since it showed the lowest MSE).
\item days with abnormal rise/fall of levels (\eg{} 25 April) were not treated as errors and thus were not interpolated
\end{itemize}

\subsection{Assumptions}
\label{sec:methods-assumptions}
A number of assumptions had been made in order to simulate timelines:
\begin{itemize}
\item initial \no{} exposed
\item initial \no{} protected
\item initial \no{} asymptomatics (undetected)
\item undetected deaths (\wrt{} confirmed deaths)
\end{itemize}

\subsection{Simulation}
\label{sec:methods-simulation}
Let
\begin{align}
Y(t) = Y^t &= \left(
\begin{bmatrix}
           s_1(t) \\
           s_2(t) \\
           \ldots \\
           s_m(t)
\end{bmatrix}
\right) \\
\end{align}
the vector consisting of the states levels at time $t$. We can model the time evolution of the PDE system splitting the PDE system into a linear component ($A$) and a non-linear component ($F$) such that
\begin{equation}
Y^{t + 1} = A \cdot Y^t + F(t) \label{eq:Y_iter}
\end{equation}
Let $A$ being the square matrix such that $a_{ij}$ is the coefficient in the PDE system that models the interaction between state $s_i$ and $s_j$. The columns of $A$ will sum to 0 (due to conservation of individuals):
\begin{align}
A = \left(
\begin{bmatrix}
           a_{s_1 \rightarrow s_1}, a_{s_2 \rightarrow s_1}, \ldots a_{s_m, \rightarrow s_1} \\
           \ldots \\
           a_{s_1 \rightarrow s_m}, a_{s_2 \rightarrow s_m}, \ldots a_{s_m, \rightarrow s_m}
\end{bmatrix}
\right) \\
\end{align}
$F$ is just a vector depending on the time-step and it models the non-linear interactions between states. In our case
\begin{align}
F(t) = \left(
\begin{bmatrix}
           - \it{b} S(t) \cdot \frac{I_{u}(t)}{N - \left(D(t) + H_m(t) + H_s(t) + I_{cu}(t) \right)} \\
           \it{b} S(t) \cdot \frac{I_{u}(t)}{N - \left(D(t) + H_m(t) + H_s(t) + I_{cu}(t) \right)} \\
           0 \\
           \ldots \\
           0
\end{bmatrix}
\right) \\
\end{align}
Then we can solve the PDE system using standard methods of integration. We chose RK4. \todo{} why?

\subsubsection{Mixing matrices}
\label{subsec:methods-mixing-matrices}
Define a \textit{population class} $c \in C$ being a subset of the population whose individuals share a common attribute. In our case we divided the population into \textit{age classes}: $\{ 0-9 \text{ years old}, 10-19 \text{ years old}, \dots, 80-89 \text{ years old}, 90+ \text{ years old} \}$.
To model the interactions across some $c_i$ and $c_j$ we used a so called \textit{mixing matrix} $M$. $M_{ij}$ models the rate of interaction between $c_i$ and $c_j$.
\todo{} where we found these?

\subsection{Fitting}
\label{sec:methods-fit}
The fitting algorithms takes some input values (initial conditions, assumptions \ldots) and outputs the required coefficients to solve \eq[Y_iter]{} (matrix $A$ and the constants in the non-linear component). The algorithm
\begin{enumerate}
\item parses dataset
\item initializes variables
\item runs optimization until threshold is matched
\item calculates statistical significance of results
\end{enumerate}
The algorithms was implemented to be as accessible and customizable as possible: the code is open-sourced with default values.

\subsubsection{Normalization}
\label{subsec:methods-normalization}
Timelines were parsed and normalized before actual algorithm was run: the number scales across even a single timeline was a great thus we perfomed standard $\log$-normalization.

\subsubsection{Initialization}
\label{subsec:methods-initialization}
We increased number of simulation steps (decreased time step) in order to make the algorithm converge even with badly posed initial values.

\subsubsection{Optimization function}
\label{subsec:methods-optimization}
For each set of parameters we simulated the timelines and exptrapolated at discrete timesteps to compute the $L_2$-norm (ridge-regression) of the error (when compared to true normalized values). We used MATLAB standard nonlinear least-squares solver (Levenberg–Marquardt algorithm) and specified some parameters bounds.

\subsubsection{CI}
\label{subsec:methods-CI}
From the Jacobian we computed the $95\%$-\textit{confidence intervals}.
